for bits in {32,64,128}; do
  for u in {-1,1}; do
    for nt in {10,30}; do
      for dom in {serial,openmp,threads}; do
        for nk in {1,2,4,5,20}; do
          for adv in {upstream,mpdata,leapfrog}; do
            if [ $dom = "serial" -a $nk != 1 ]; then continue; fi 
            cmd="../cw5 --dt 1 --dx 1 --nx 20"
            cmd="$cmd --bits $bits --u $u --nt $nt --adv $adv --dom $dom --nk $nk"
            ret=`$cmd 2>/dev/null` 
            if [ $? != "0" ]; then 
              echo "exited with non-zero status for: " $cmd
              exit 1;  
            fi
            ret=`echo "$ret" | awk 'BEGIN {RS="   "} {print}' | tail -21 | tr "\n" " "`
            if [ "$ret" != '0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0 0  ' ]; then 
              echo "wrong result: $ret" 
              echo "command: " $cmd
              exit 1;  
            fi
            echo "OK for: " $cmd
          done # adv
        done # nk
      done # dom
    done # nt
  done # u
done # bits
